// SETTIME.C - Set system time dialog procedure

#include <windowsx.h>
#include <stdio.h>
#include <dos.h>
#include <time.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "dgtlclk.h"
#include "settime.h"

BOOL CALLBACK _export SetTimeDlgProc(HWND hDlg, UINT msg,
									 WPARAM wParam, LPARAM lParam);


BOOL CALLBACK _export SetTimeDlgProc(HWND hDlg, UINT msg,
									 WPARAM wParam, LPARAM lParam)
{
	static struct dostime_t t;
	static char szHour[3], szMinute[3], szSecond[3];
	static int Hour, Minute, Second;
	static BOOL IsPm;
    static HWND hHScroll, hMScroll, hSScroll;

	switch (msg)
	{
		case WM_INITDIALOG:
		{
			hHScroll = GetDlgItem(hDlg, IDC_HOURSCROLL);
			hMScroll = GetDlgItem(hDlg, IDC_MINSCROLL);
			hSScroll = GetDlgItem(hDlg, IDC_SECSCROLL);

			_dos_gettime(&t);

			IsPm = (t.hour >= 12) ? TRUE : FALSE;
			t.hsecond = 0;
			Hour = (int)((t.hour % 12) ? (t.hour % 12) : 12);
			Minute = (int)t.minute;
            Second = (int)t.second;

			sprintf(szHour, "%2d", Hour);
			sprintf(szMinute, "%02d", Minute);
			sprintf(szSecond, "%02d", Second);
			SetWindowText(GetDlgItem(hDlg, IDC_HOUREDIT), (LPSTR)szHour);
			SetWindowText(GetDlgItem(hDlg, IDC_MINEDIT), (LPSTR)szMinute);
			SetWindowText(GetDlgItem(hDlg, IDC_SECEDIT), (LPSTR)szSecond);

			if (IsPm)
				CheckRadioButton(hDlg, IDC_AMBTN, IDC_PMBTN, IDC_PMBTN);
			else
				CheckRadioButton(hDlg, IDC_AMBTN, IDC_PMBTN, IDC_AMBTN);

			SetScrollRange(hHScroll, SB_CTL, 1, 13, FALSE);
			SetScrollRange(hMScroll, SB_CTL, 0, 60, FALSE);
			SetScrollRange(hSScroll, SB_CTL, 0, 60, FALSE);
			SetScrollPos(hHScroll, SB_CTL, Hour, FALSE);
			SetScrollPos(hMScroll, SB_CTL, Minute, FALSE);
			SetScrollPos(hSScroll, SB_CTL, Second, FALSE);
		}
			return TRUE;
		case WM_VSCROLL:
		{
			int n = (HWND)HIWORD(lParam);

			switch (wParam)
			{
				case SB_LINEUP:
					if (n == hHScroll) { Hour++; break; }
					else if (n == hMScroll) { Minute++; break; }
					else if (n == hSScroll) { Second++; break; }
                    break;
				case SB_LINEDOWN:
					if (n == hHScroll) { Hour--; break; }
					else if (n == hMScroll) { Minute--; break; }
					else if (n == hSScroll) { Second--; break; }
					break;
			}
			if (Hour > 12) Hour = 1;
            else if (Hour < 1) Hour = 12;
			if (Minute > 59) Minute = 0;
            else if (Minute < 0) Minute = 59;
			if (Second > 59) Second = 0;
			else if (Second < 0) Second = 59;

			sprintf(szHour, "%2d", Hour);
			sprintf(szMinute, "%02d", Minute);
			sprintf(szSecond, "%02d", Second);
			SetWindowText(GetDlgItem(hDlg, IDC_HOUREDIT), (LPSTR)szHour);
			SetWindowText(GetDlgItem(hDlg, IDC_MINEDIT), (LPSTR)szMinute);
			SetWindowText(GetDlgItem(hDlg, IDC_SECEDIT), (LPSTR)szSecond);
		}
			return TRUE;
		case WM_COMMAND:
			switch (wParam)
			{
				case IDOK:
/*
					GetWindowText(GetDlgItem(hDlg, IDC_HOUREDIT),
								  (LPSTR)szHour, sizeof(szHour));
					GetWindowText(GetDlgItem(hDlg, IDC_MINEDIT),
								  (LPSTR)szMinute, sizeof(szMinute));
					GetWindowText(GetDlgItem(hDlg, IDC_SECEDIT),
								  (LPSTR)szSecond, sizeof(szSecond));
*/
					IsPm = (BOOL)IsDlgButtonChecked(hDlg, IDC_PMBTN) ? 1 : 0;

					if (IsPm)
						t.hour = (unsigned char)Hour + 12;
					else
						t.hour = (unsigned char)Hour;
					t.minute = (unsigned char)Minute;
					t.second = (unsigned char)Second;
					t.hsecond = (unsigned char)0;

					_dos_settime(&t);

					SendMessage(hDlg, WM_CLOSE, wParam, 0L);
                    return TRUE;
				case IDCANCEL:
					SendMessage(hDlg, WM_CLOSE, wParam, 0L);
                    return TRUE;
			}
			return TRUE;
		case WM_SETFOCUS:
        	return FALSE;
		case WM_PAINT:
        {
			return (BOOL)NULL;
        }
		case WM_CLOSE:
			EndDialog(hDlg, wParam);
			return TRUE;
	}
    return FALSE;
}


